-- This is a quick and dirty routine that translates an address to an ASCII
-- string which always has a leading zero.

with Apex_System_Constants;
with System;
with Unchecked_Conversion;
with Apex_Modular_Type_To_String;

function Apex_Address_To_String (Adr : System.Address) return String is

    pragma Suppress_All;

    package Amtts renames Apex_Modular_Type_To_String;

    type Modular_Address is mod 2 ** (Apex_System_Constants.Size_Of_Address);
    function To_Modular_Address is new Unchecked_Conversion
                                          (System.Address, Modular_Address);

begin
    return Amtts.Convert (Amtts.Largest_Modular_Type
                             (To_Modular_Address (Adr)),
                          Apex_System_Constants.Size_Of_Address);
end Apex_Address_To_String;

