-- This is a quick and dirty routine that translates a modular type to an ASCII
-- string which always has leading zeroes.


package body Apex_Modular_Type_To_String is

    function Convert (Val : Largest_Modular_Type; Actual_Size : Size_Range)
                     return String is

        Return_String : String (1 .. Natural ((Actual_Size + 3) / 4) + 1) :=
           (others => '0');
        Idx : Natural := Return_String'Last;
        Value : Largest_Modular_Type := Val;
        Nibble : Largest_Modular_Type;

        type Natural_String is array (Natural range <>) of Character;
        Hex : constant Natural_String (0 .. 15) := "0123456789abcdef";

    begin
        while Value /= 0 loop
            Nibble := Value and 16#F#;
            Return_String (Idx) := Hex (Natural (Nibble));
            Idx := Idx - 1;
            Value := Value / 16;  -- shift right by four bits
        end loop;
        return Return_String;
    end Convert;

end Apex_Modular_Type_To_String;

