with Unchecked_Conversion;
with V_I_Except;

package body Apex_Occurrence_Utils is

    function Traceback_Regs_Get (Occurrence : Exception_Occurrence_Access)
                                return Apex_Stack_Trace_Types.
                                       Traceback_Regs_Rec_Access is
    begin
        return Apex_Stack_Trace_Types.To_Traceback_Regs_Rec_Access
                  (V_I_Except.Exception_Occurrence_Traceback_Regs
                      (Occurrence));
    end Traceback_Regs_Get;


    function Next_Get (Occurrence : Exception_Occurrence_Access)
                      return Exception_Occurrence_Access is
    begin
        return V_I_Except.Exception_Occurrence_Next (Occurrence);
    end Next_Get;


    -- This code was lifted from the body of Ada.Exceptions.

    function Exception_Name (Id : V_I_Except.Exception_Id) return String is
        use V_I_Except;
    begin
        if Id = null then
            -- Ada RM95 11.4.1(14)
            raise Constraint_Error;
        else
            declare
                Addr : System.Address := Id.all'Address;
                type Byte is range 0 .. 255;
                type Byte_String is array (1 .. 2048) of Byte;
                pragma Pack (Byte_String);
                Thing : Byte_String;
                for Thing use at Addr;
                pragma Import (Ada, Thing);
                B : Integer := 5;
            begin
                -- exception has a leading 32-bit number (even on 64-bit
                -- targets) followed by a null-terminated name

                while Thing (B) /= 0 loop
                    B := B + 1;
                end loop;
                declare
                    Image : String (1 .. B - 5);
                begin
                    for C in 5 .. B - 1 loop
                        Image (C - 4) := Character'Val (Thing (C));
                    end loop;
                    return Image;
                end;
            end;
        end if;
    end Exception_Name;


    function Exception_Name
                (Occurrence : Exception_Occurrence_Access) return String is
    begin
        return Exception_Name
                  (V_I_Except.Exception_Occurrence_Id (Occurrence));
    end Exception_Name;


    function Exception_Message
                (Occurrence : Exception_Occurrence_Access) return String is
    begin
        -- Not implemented nor needed for Ada83.
        return "";
    end Exception_Message;


    procedure Exception_Information_Callout_Install (Func : System.Address) is
    begin
        -- Not implemented nor needed for Ada83.
        null;
    end Exception_Information_Callout_Install;


end Apex_Occurrence_Utils;
