with Apex_Occurrence_Types;
with Apex_Stack_Trace_Types;
with Apex_Stack_Trace_Io_Os_Types;

package Apex_Stack_Trace_Io is

    subtype File_Descriptor is Apex_Stack_Trace_Io_Os_Types.File_Descriptor;

    function Open (Filename : String; Append : Boolean := False)
                  return File_Descriptor;
    pragma Suppress (Elaboration_Check, On => Open);

    procedure Close (Fd : File_Descriptor);
    pragma Suppress (Elaboration_Check, On => Close);

    procedure Dump_Trace_Label (Fd : File_Descriptor; Label : String);
    pragma Suppress (Elaboration_Check, On => Dump_Trace_Label);

    procedure Dump_Registers (Fd : File_Descriptor;
                              Occurrence : Apex_Occurrence_Types.
                                              Exception_Occurrence_Access);
    pragma Suppress (Elaboration_Check, On => Dump_Registers);

    procedure Dump_Stack_Trace (Fd : File_Descriptor;
                                Context : Apex_Stack_Trace_Types.Frame_Access);
    pragma Suppress (Elaboration_Check, On => Dump_Stack_Trace);

end Apex_Stack_Trace_Io;

