with Apex_Occurrence_Utils;

separate (Apex_Stack_Trace_Io)
package body Machine_Dependent is

    pragma Suppress_All;

    procedure Dump_Registers (Fd : File_Descriptor;
                              Occurrence : Apex_Occurrence_Types.
                                              Exception_Occurrence_Access) is
        Traceback_Regs : Apex_Stack_Trace_Types.Traceback_Regs_Rec_Access :=
           Apex_Occurrence_Utils.Traceback_Regs_Get (Occurrence);
        function To_Register is new Unchecked_Conversion
                                       (System.Address, Register);
    begin
        Dump_Four_Registers (Fd, "Eax", To_Register (Traceback_Regs.Eax),
                             "Ecx", To_Register (Traceback_Regs.Ecx),
                             "edx", To_Register (Traceback_Regs.Edx),
                             "ebx", To_Register (Traceback_Regs.Ebx));
        Dump_Four_Registers (Fd, "esp", To_Register (Traceback_Regs.Esp),
                             "ebp", To_Register (Traceback_Regs.Ebp),
                             "esi", To_Register (Traceback_Regs.Esi),
                             "edi", To_Register (Traceback_Regs.Edi));
        Dump_Four_Registers (Fd, "Eflags", To_Register (Traceback_Regs.Eflags),
                             "Eip", To_Register (Traceback_Regs.Eip)
                             );

    end Dump_Registers;

end Machine_Dependent;

